#ifndef CG_PROGRAM_MANAGER_H
#define CG_PROGRAM_MANAGER_H

#include <GL/glew.h>
#include <Cg/cg.h>
#include <Cg/cgGL.h>
#include <QHash>
#include <QString>

class CgProgramWrapper;

class CgProgramManager
{
public:

	static CgProgramManager* getInstance();		
	static void destroy();

	// TODO: stringList for args?
	void loadProgramFromFile( QString programName,
		QString filename, QString entryPoint,
		CGprofile profile,
		const char** args );

	CgProgramWrapper* getNamedProgram( QString programName );
	void destroyNamedProgram( QString programName );

private:

	// =========================================================================
	// Methods
	// =========================================================================

	CgProgramManager();
	virtual ~CgProgramManager();

	// =========================================================================
	// Fields
	// =========================================================================

	static CgProgramManager* s_pSingleton;

	QHash< QString, CgProgramWrapper* > m_qhPrograms;
};

#endif
