#ifndef CG_PROGRAM_WRAPPER_H
#define CG_PROGRAM_WRAPPER_H

#include <GL/glew.h>
#include <Cg/cg.h>
#include <Cg/cgGL.h>

#include <QHash>
#include <QString>

class CgProgramWrapper
{
public:
	
	static CgProgramWrapper* create( QString filename, QString entryPoint, CGcontext context, CGprofile profile );
	virtual ~CgProgramWrapper();

	bool isCompiled();

	// binds the program for execution
	void bind();

	// loads the program into the GL runtime
	void load();
	bool isLoaded();

	// returns a named program parameter
	// if it's not loaded, it will be loaded
	// returns NULL if it doesn't exist
	CGparameter getNamedParameter( QString name );

	// returns the stored program
	CGprogram getProgram();

private:

	CgProgramWrapper( CGprogram program );

	CGprogram m_cgProgram;
	QHash< QString, CGparameter > m_qhProgramParameters;

};

#endif
