#ifndef CG_SHARED_H
#define CG_SHARED_H

// singleton class for simple Cg projects
// that share a single CGContext

#include <GL/glew.h>
#include <Cg/cg.h>
#include <Cg/cgGL.h>

void cgSharedErrorHandler( CGcontext ctx, CGerror err, void* appdata );

class CgShared
{
public:

	static CgShared* getInstance();
	static void destroy();

	CGcontext getSharedCgContext() const;
	CGprofile getLatestVertexProfile() const;
	CGprofile getLatestFragmentProfile() const;

private:

	CgShared();
	virtual ~CgShared();

	static CgShared* s_pSingleton;

	CGcontext m_cgContext;
	CGprofile m_cgVertexProfile;
	CGprofile m_cgFragmentProfile;
};

#endif
