#ifndef OPEN_NATURAL_CUBIC_SPLINE
#define OPEN_NATURAL_CUBIC_SPLINE

#include <QVector>
#include <vecmath/Vector4f.h>

class OpenNaturalCubicSpline
{
public:

	OpenNaturalCubicSpline();

	void setPoints( QVector< float > points );

	// output = x( t )
	// t between 0 and 1
	float operator () ( float t ) const;

	// output = dx/dt ( t )
	// t between 0 and 1
	float derivativeAt( float t ) const;

	// get the inverse splint
	// given a value of x, find t such that x(t) = x
	float inverse( float x, float tGuess, float epsilon = 0.001f, int maxIterations = 50 ) const;

private:

	QVector< float > m_vControlPoints;
	QVector< Vector4f > m_vCoefficients;

};

#endif
