TEMPLATE = lib
CONFIG += qt thread debug_and_release staticlib

CONFIG( debug, debug|release ) {
    TARGET = libcgtd
} else {
    TARGET = libcgt
}

INCLUDEPATH += "./include"

# Cg

HEADERS += include/Cg/CgProgramManager.h
HEADERS += include/Cg/CgProgramWrapper.h
HEADERS += include/Cg/CgShared.h
HEADERS += include/Cg/CgUtilities.h

SOURCES += src/Cg/CgProgramManager.cpp
SOURCES += src/Cg/CgProgramWrapper.cpp
SOURCES += src/Cg/CgShared.cpp
SOURCES += src/Cg/CgUtilities.cpp

# color

HEADERS += include/color/ColorUtils.h
HEADERS += include/color/QImageUtils.h

SOURCES += src/color/ColorUtils.cpp
SOURCES += src/color/QImageUtils.cpp

# common

HEADERS += include/common/ArrayUtils.h
HEADERS += include/common/ArrayWithLength.h
HEADERS += include/common/BasicTypes.h
HEADERS += include/common/QAtomicQueue.h
HEADERS += include/common/Reference.h
HEADERS += include/common/ReferenceCountedArray.h

SOURCES += src/common/ArrayUtils.cpp

# geometry

HEADERS += include/geometry/BoundingBox2f.h
HEADERS += include/geometry/BoundingBox3f.h
# HEADERS += include/geometry/BSPTree.h # TODO: fix this class
HEADERS += include/geometry/GeometryUtils.h
HEADERS += include/geometry/IndexedFace.h
HEADERS += include/geometry/OpenNaturalCubicSpline.h
# HEADERS += include/geometry/Triangle3f.h # TODO: get rid of this
HEADERS += include/geometry/TriangleList3f.h
# HEADERS += include/geometry/TriangleMesh3f.h # TODO: fix this class

SOURCES += src/geometry/BoundingBox2f.cpp
SOURCES += src/geometry/BoundingBox3f.cpp
# SOURCES += src/geometry/BSPTree.cpp
SOURCES += src/geometry/Geometry.cpp
SOURCES += src/geometry/GeometryUtils.cpp
SOURCES += src/geometry/IndexedFace.cpp
SOURCES += src/geometry/OpenNaturalCubicSpline.cpp
# TODO: remove altogether SOURCES += src/geometry/Triangle3f.cpp
SOURCES += src/geometry/TriangleList3f.cpp
# SOURCES += src/geometry/TriangleMesh3f.cpp # TODO: fix this class

# GL

HEADERS += include/GL/GLBufferObject.h
HEADERS += include/GL/GLBufferObjectManager.h
HEADERS += include/GL/GLCamera.h
HEADERS += include/GL/GLFrameBufferObject.h # TODO: unify with uc davis FrameBufferObjectClass on sourceforge
HEADERS += include/GL/GLInitializable.h
HEADERS += include/GL/GLOcclusionQuery.h
HEADERS += include/GL/GLPerspectiveCamera.h
HEADERS += include/GL/GLShared.h
HEADERS += include/GL/GLTexture1D.h
HEADERS += include/GL/GLTexture2D.h
HEADERS += include/GL/GLTexture3D.h
HEADERS += include/GL/GLTexture.h
HEADERS += include/GL/GLTextureRectangle.h
HEADERS += include/GL/GLUtilities.h
HEADERS += include/GL/GLVertexBufferObject.h # TODO: rename to GLVertexBufferObjectFactory

SOURCES += src/GL/GLBufferObject.cpp
SOURCES += src/GL/GLBufferObjectManager.cpp
SOURCES += src/GL/GLCamera.cpp
SOURCES += src/GL/GLFrameBufferObject.cpp # TODO: unify with uc davis FrameBufferObjectClass on sourceforge
SOURCES += src/GL/GLOcclusionQuery.cpp
SOURCES += src/GL/GLPerspectiveCamera.cpp
SOURCES += src/GL/GLShared.cpp
SOURCES += src/GL/GLTexture1D.cpp
SOURCES += src/GL/GLTexture2D.cpp
SOURCES += src/GL/GLTexture3D.cpp
SOURCES += src/GL/GLTexture.cpp
SOURCES += src/GL/GLTextureRectangle.cpp
SOURCES += src/GL/GLUtilities.cpp
SOURCES += src/GL/GLVertexBufferObject.cpp # TODO: rename to GLVertexBufferObjectFactory

# io

# TODO: move to its own module?
HEADERS += include/io/OBJData.h
HEADERS += include/io/OBJFace.h
HEADERS += include/io/OBJGroup.h
HEADERS += include/io/OBJLoader.h
HEADERS += include/io/OpenEXRIO.h
HEADERS += include/io/PortableFloatMapIO.h
HEADERS += include/io/PortablePixelMapIO.h

SOURCES += src/io/OBJData.cpp
SOURCES += src/io/OBJFace.cpp
SOURCES += src/io/OBJGroup.cpp
SOURCES += src/io/OBJLoader.cpp
SOURCES += src/io/OpenEXRIO.cpp
SOURCES += src/io/PortableFloatMapIO.cpp
SOURCES += src/io/PortablePixelMapIO.cpp

# math

HEADERS += include/math/Arithmetic.h
HEADERS += include/math/MathUtils.h
HEADERS += include/math/MersenneTwister.h
HEADERS += include/math/Random.h
HEADERS += include/math/Sampling.h
HEADERS += include/math/SamplingPatternND.h

SOURCES += src/math/Arithmetic.cpp
SOURCES += src/math/MathUtils.cpp
SOURCES += src/math/Random.cpp
SOURCES += src/math/Sampling.cpp
SOURCES += src/math/SamplingPatternND.cpp

# time

HEADERS += include/time/Clock.h
HEADERS += include/time/CrossPlatformSleep.h
HEADERS += include/time/QGameLoop.h
HEADERS += include/time/StopWatch.h

SOURCES += src/time/Clock.cpp
SOURCES += src/time/CrossPlatformSleep.cpp
SOURCES += src/time/QGameLoop.cpp
SOURCES += src/time/StopWatch.cpp

# vecmath

HEADERS += include/vecmath/GMatrixd.h
HEADERS += include/vecmath/Matrix2f.h
HEADERS += include/vecmath/Matrix3f.h
HEADERS += include/vecmath/Matrix4f.h
HEADERS += include/vecmath/Quat4f.h
# HEADERS += include/vecmath/SparseMatrix.h # refactor out
HEADERS += include/vecmath/Vector2d.h
HEADERS += include/vecmath/Vector2f.h
HEADERS += include/vecmath/Vector2i.h
HEADERS += include/vecmath/Vector3d.h
HEADERS += include/vecmath/Vector3f.h
HEADERS += include/vecmath/Vector3i.h
HEADERS += include/vecmath/Vector4d.h
HEADERS += include/vecmath/Vector4f.h

SOURCES += src/vecmath/GMatrixd.cpp
SOURCES += src/vecmath/Matrix2f.cpp
SOURCES += src/vecmath/Matrix3f.cpp
SOURCES += src/vecmath/Matrix4f.cpp
SOURCES += src/vecmath/Quat4f.cpp
# SOURCES += src/vecmath/SparseMatrix.cpp
SOURCES += src/vecmath/Vector2d.cpp
SOURCES += src/vecmath/Vector2f.cpp
SOURCES += src/vecmath/Vector2i.cpp
SOURCES += src/vecmath/Vector3d.cpp
SOURCES += src/vecmath/Vector3f.cpp
SOURCES += src/vecmath/Vector3i.cpp
SOURCES += src/vecmath/Vector4d.cpp
SOURCES += src/vecmath/Vector4f.cpp

# video

HEADERS += include/video/IVideo.h
HEADERS += include/video/ImageDirectoryVideo.h
HEADERS += include/video/QDecoderThread.h
# HEADERS += include/video/SimpleVideo.h # TODO: remove this
HEADERS += include/video/FFMPEGVideo.h

SOURCES += src/video/ImageDirectoryVideo.cpp
SOURCES += src/video/QDecoderThread.cpp
# SOURCES += src/video/SimpleVideo.cpp # TODO: remove this
SOURCES += src/video/FFMPEGVideo.cpp
