#include "time/Clock.h"

//////////////////////////////////////////////////////////////////////////
// Public
//////////////////////////////////////////////////////////////////////////

Clock::Clock()
{
	LARGE_INTEGER frequency;
	QueryPerformanceFrequency( &frequency );
	m_liFrequency = ( float )( frequency.QuadPart );
}

int64 Clock::getCounterValue()
{
	LARGE_INTEGER counter;
	QueryPerformanceCounter( &counter );
	return counter.QuadPart;
}

float Clock::getFrequency()
{
	return m_liFrequency;
}

float Clock::convertIntervalToMillis( int64 interval )
{
	float seconds = ( ( float )interval ) / m_liFrequency;
	return( seconds * 1000.f );
}

int64 Clock::convertMillisToCounterInterval( float millis )
{
	float seconds = millis / 1000.f;
	float counts = seconds * m_liFrequency;
	return( ( int64 )counts );
}
